.386
.model flat,stdcall
option casemap:none

CloseHandle	PROTO :DWORD
CreateFileA	PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
CreateFile	equ <CreateFileA>

WriteFile	PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

INVALID_HANDLE_VALUE    equ -1
GENERIC_WRITE           equ 40000000h
CREATE_ALWAYS           equ 2
FILE_ATTRIBUTE_ARCHIVE  equ 20h

PUBLIC  WriteFileToDisc@12

.code

;   WriteFileToDisc PROC pFileName:DWORD,pMemory:DWORD,nSize:DWORD

;   pFileName       :   pointer to file name
;   pMemory         :   address of data block to write to disc
;   nSize           :   number of bytes to write

;   Return values   :   if the function succeeds, eax is equal to 2
;                   :   if the function fails, the return value is NULL    


WriteFileToDisc@12:

    sub     esp,2*4                 ; reserve 8 bytes for local variables
    invoke  CreateFile,DWORD PTR [esp+36],GENERIC_WRITE,0,0,\
            CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,0
    cmp     eax,INVALID_HANDLE_VALUE
    je      finish
@@:
    mov     DWORD PTR [esp],eax     ; save the handle to the file
    lea     edx,DWORD PTR [esp+4]   ; get the address of number of bytes written
    invoke  WriteFile,eax,DWORD PTR [esp+28],DWORD PTR [esp+28],edx,0
    test    eax,eax
    jnz     @f
    mov     eax,1
    jmp     finish
@@:    
    invoke  CloseHandle,DWORD PTR [esp]
    test    eax,eax
    jz      finish
    mov     eax,2
 
finish:

    add     esp,2*4                 ; balance the stack
    ret     3*4

;   ENDP WriteFileToDisc

END
